﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Tesseract;
using PdfSharp.Drawing;
using PdfSharp.Pdf;

namespace SuzukiScan
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //dlgOpenFile.ShowDialog();
            //Bitmap src = (Bitmap)Image.FromFile(dlgOpenFile.FileName);
            //Rectangle cropRect = new Rectangle(2000,600,400,150);
            Rectangle cropRect = new Rectangle(int.Parse(txtX.Text), int.Parse(txtY.Text), int.Parse(txtWidth.Text), int.Parse(txtHeight.Text));

            string strTiff = string.Empty;
            if(txtPDF.Text.ToUpper().EndsWith("PDF"))
            { strTiff = GhostToTiff(txtPDF.Text); }
            else
            { strTiff = dlgOpenFile.FileName; }
            Image cTiff = Image.FromFile(strTiff);
            int iPages = cTiff.GetFrameCount(FrameDimension.Page);

            for (int iPage = 0; iPage < iPages; iPage++)
            {
                bool bOK = true;

                cTiff.SelectActiveFrame(FrameDimension.Page, iPage);
                MemoryStream byteStream = new MemoryStream();
                cTiff.Save(byteStream, System.Drawing.Imaging.ImageFormat.Bmp);
                Bitmap bmpPage = (Bitmap)Image.FromStream(byteStream);

                int n;
                string strText = tesocr(bmpPage, cropRect);
                string strCustomerNr = strText.Split(':')[1].Trim();

                if ((bool)int.TryParse(strCustomerNr, out n) == false)
                {
                    strText = tesocr(bmpPage, cropRect,"deu");
                    strCustomerNr = strText.Split(':')[1].Trim();                
                }
                Application.DoEvents();

                if (chkAsk.Checked)
                {
                    while ((bool)int.TryParse(strCustomerNr, out n) == false)
                    {
                        frmCustomerNr nInput = new frmCustomerNr(strCustomerNr);
                        nInput.ShowDialog();
                        strCustomerNr = nInput.CustomerNr;
                    }
                }
                else
                {
                    if ((bool)int.TryParse(strCustomerNr, out n) == false)
                    {
                        bOK = false;
                    }
                }

                txtTest.Text = strCustomerNr;




                PdfDocument cDocument = new PdfDocument();// = new PdfDocument(Application.StartupPath + "\\TEMP\\" + strCustomerNr + ".pdf");
                PdfPage cPage = cDocument.AddPage();
                
                
                using (XImage img = (XImage)bmpPage)
                {
                    //// Calculate new height to keep image ratio
                    //var height = (int)(((double)width / (double)img.PixelWidth) * img.PixelHeight);

                    //// Change PDF Page size to match image
                    //cPage.Width = width;
                    //cPage.Height = height;

                    cPage.Size = PdfSharp.PageSize.A4;

                    XGraphics gfx = XGraphics.FromPdfPage(cPage);
                    gfx.DrawImage(img, 0, 0, cPage.Width , cPage.Height);
                }
                if (bOK)
                { cDocument.Save(txtTargetPath.Text + "\\" + strCustomerNr + ".pdf"); }
                else
                {
                    if (!Directory.Exists(txtTargetPath.Text + "\\BAD"))
                    { Directory.CreateDirectory(txtTargetPath.Text + "\\BAD"); }
                    cDocument.Save(txtTargetPath.Text + "\\BAD\\" + strCustomerNr + ".pdf");
                }
                

                //if (!Directory.Exists(Application.StartupPath + "\\TEMP"))
                //{ Directory.CreateDirectory(Application.StartupPath + "\\TEMP"); }

                //bmpPage.Save(Application.StartupPath + "\\TEMP\\" + strCustomerNr + ".bmp");
                //bmpPage.Dispose();
                //bmpPage = null;

                //GhostToPdf(Application.StartupPath + "\\TEMP\\" + strCustomerNr + ".bmp", Application.StartupPath + "\\TEMP\\" + strCustomerNr + ".pdf");

            }

            try
            {
                cTiff.Dispose();
                cTiff = null;
                File.Delete(strTiff);
            }
            catch (Exception ex)
            {
                //No Problem, ignore it!    
            }

            MessageBox.Show("Fertisch!");



        }


        string tesocr(Bitmap src, Rectangle cropRect,string lng = "eng")
        {
            Bitmap croped = src.Clone(cropRect, src.PixelFormat);
            pictureBox1.Image = croped;

            TesseractEngine enginge = new TesseractEngine("./tessdata", lng, EngineMode.Default);
            Page cResult = enginge.Process(croped, PageSegMode.Auto);
            string strResult = cResult.GetText();
            txtTest.Text = strResult;
            Application.DoEvents();
            return strResult;
        }

        string GhostToTiff(string cPDF)
        {
            if(!Directory.Exists(Application.StartupPath + "\\TEMP"))
            { Directory.CreateDirectory(Application.StartupPath + "\\TEMP"); }

            string strTiff = Application.StartupPath + "\\TEMP\\" + DateTime.Now.ToString().Replace(":", "").Replace(".", "").Replace(" ","") + ".tiff";


            System.Diagnostics.Process GhostScript = new System.Diagnostics.Process();
            GhostScript = System.Diagnostics.Process.Start(txtGhostScript.Text
                , "-dNOPAUSE -dBATCH -sDEVICE=tiffgray -r" + txtResolution.Text + " -sOutputFile=\"" + strTiff  + "\" " +
                "\"" + cPDF + "\"");
            
            while (!GhostScript.HasExited)
            {
                Application.DoEvents();
                System.Threading.Thread.Sleep(200);
            }
            return strTiff;
        }

        void GhostToPdf(string cTiff, string strTargetFile)
        {
            System.Diagnostics.Process GhostScript = new System.Diagnostics.Process();
            GhostScript = System.Diagnostics.Process.Start(txtGhostScript.Text
                , "-dNOPAUSE -dBATCH -sDEVICE=pdfwrite -sOutputFile=\"" + strTargetFile + "\" " +
                "\"" + cTiff + "\"");

            while (!GhostScript.HasExited)
            {
                Application.DoEvents();
                System.Threading.Thread.Sleep(200);
            }
        }

        private void cmdOpenTargetPath_Click(object sender, EventArgs e)
        {
            if (dlgBrowseFolder.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            { txtTargetPath.Text = dlgBrowseFolder.SelectedPath; }
        }

        private void cmdOpenPDF_Click(object sender, EventArgs e)
        {
            if (dlgOpenFile.ShowDialog() == DialogResult.OK)
            { txtPDF.Text = dlgOpenFile.FileName; }
        }
    }
}
